#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n, k;
    cin >> n >> k;
    int niz[n];
    for(int i=0;i<n;++i){
        cin >> niz[i];
    }
    int res=0;
    if(k==2){
        int maks=niz[0];
        int mini=niz[0];

        for(int i=0;i<n;++i){
            if(niz[i]>maks){
                maks=niz[i];
            }
            if(niz[i]<mini){
                mini=niz[i];
            }
        }

        res=maks-mini;

    }
    else if(k==n){
        int l=0, r=n-1;
        while (l < r){
            if(l==r){
                res=niz[l];
            }
            else if(niz[l]-niz[r]>niz[r]-niz[l]){
                r--;
                niz[l]-=niz[r];
            }
            else{
                l--;
                niz[r]-=niz[l];
            }
        }
    }else{
        res = niz[n/2];
    }


    cout <<res;
    return 0;
}